Index: trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 8083)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 8126)
@@ -240,5 +240,5 @@
            !debug this section computing ?
            lldebug=.FALSE.
-           IF( (jsec==nn_secdebug .OR. nn_secdebug==-1) .AND.  kt==nit000+nn_dct-1 .AND. lwp ) lldebug=.TRUE. 
+           IF( (jsec==nn_secdebug .OR. nn_secdebug==-1) .AND.  kt==nit000+nn_dct-1 ) lldebug=.TRUE. 
 
            !Compute transport through section  
@@ -249,5 +249,5 @@
         IF( MOD(kt,nn_dctwri)==0 )THEN
 
-           IF( lwp .AND. kt==nit000+nn_dctwri-1 )WRITE(numout,*)"      diadct: average transports and write at kt = ",kt         
+           IF( kt==nit000+nn_dctwri-1 )WRITE(numout,*)"      diadct: average transports and write at kt = ",kt         
   
            !! divide arrays by nn_dctwri/nn_dct to obtain average 
@@ -335,5 +335,5 @@
      DO jsec=1,nb_sec_max      !loop on the nb_sec sections
 
-        IF ( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) ) &
+        IF (  jsec==nn_secdebug .OR. nn_secdebug==-1  ) &
            & WRITE(numout,*)'debuging for section number: ',jsec 
 
@@ -355,5 +355,5 @@
         IF( jsec .NE. isec )  CALL ctl_stop( cltmp )
 
-        IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )WRITE(numout,*)"isec ",isec 
+        IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )WRITE(numout,*)"isec ",isec 
 
         READ(numdct_in)secs(jsec)%name
@@ -374,5 +374,5 @@
         !-----
 
-        IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )THEN
+        IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )THEN
           
             WRITE(clformat,'(a,i2,a)') '(A40,', nb_class_max,'(f8.3,1X))' 
@@ -407,5 +407,5 @@
            !debug
            !-----
-           IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )THEN
+           IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )THEN
               WRITE(numout,*)"      List of points in global domain:"
               DO jpt=1,iptglo
@@ -441,5 +441,5 @@
            !debug
            !-----
-           IF(   lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )THEN
+           IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )THEN
               WRITE(numout,*)"      List of points selected by the proc:"
               DO jpt = 1,iptloc
@@ -459,5 +459,5 @@
            !remove redundant points between processors
            !------------------------------------------
-           lldebug = .FALSE. ; IF ( (jsec==nn_secdebug .OR. nn_secdebug==-1) .AND. lwp ) lldebug = .TRUE.
+           lldebug = .FALSE. ; IF ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) lldebug = .TRUE.
            IF( iptloc .NE. 0 )THEN
               CALL removepoints(secs(jsec),'I','top_list',lldebug)
@@ -475,5 +475,5 @@
            !debug
            !-----
-           IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )THEN
+           IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )THEN
               WRITE(numout,*)"      List of points after removepoints:"
               iptloc = secs(jsec)%nb_point
@@ -487,5 +487,5 @@
 
         ELSE  ! iptglo = 0
-           IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )&
+           IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )&
               WRITE(numout,*)'   No points for this section.'
         ENDIF
@@ -695,5 +695,5 @@
             !     LOOP ON THE LEVEL     | 
             !---------------------------| 
-            DO jk = 1, mbathy(k%I,k%J)            !Sum of the transport on the vertical
+            DO jk = 1, mbkt(k%I,k%J)            !Sum of the transport on the vertical
             !           ! compute temperature, salinity, insitu & potential density, ssh and depth at U/V point 
             SELECT CASE( sec%direction(jseg) )
@@ -874,5 +874,5 @@
            !---------------------------| 
            !Sum of the transport on the vertical  
-           DO jk=1,mbathy(k%I,k%J) 
+           DO jk=1,mbkt(k%I,k%J) 
  
               ! compute temperature, salinity, insitu & potential density, ssh and depth at U/V point 