Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 8126)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/NEMO/OPA_SRC/DIA/diadct.F90	(revision 8127)
@@ -249,5 +249,5 @@
            !debug this section computing ?
            lldebug=.FALSE.
-           IF( (jsec==nn_secdebug .OR. nn_secdebug==-1) .AND.  kt==nit000+nn_dct-1 .AND. lwp ) lldebug=.TRUE. 
+           IF( (jsec==nn_secdebug .OR. nn_secdebug==-1) .AND.  kt==nit000+nn_dct-1 ) lldebug=.TRUE. 
 
            !Compute transport through section  
@@ -258,5 +258,5 @@
         IF( MOD(kt,nn_dctwri)==0 )THEN
 
-           IF( lwp .AND. kt==nit000+nn_dctwri-1 )WRITE(numout,*)"      diadct: average transports and write at kt = ",kt         
+           IF( kt==nit000+nn_dctwri-1 )WRITE(numout,*)"      diadct: average transports and write at kt = ",kt         
   
            !! divide arrays by nn_dctwri/nn_dct to obtain average 
@@ -344,5 +344,5 @@
      DO jsec=1,nb_sec_max      !loop on the nb_sec sections
 
-        IF ( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) ) &
+        IF ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) &
            & WRITE(numout,*)'debuging for section number: ',jsec 
 
@@ -364,5 +364,5 @@
         IF( jsec .NE. isec )  CALL ctl_stop( cltmp )
 
-        IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )WRITE(numout,*)"isec ",isec 
+        IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )WRITE(numout,*)"isec ",isec 
 
         READ(numdct_in)secs(jsec)%name
@@ -383,5 +383,5 @@
         !-----
 
-        IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )THEN
+        IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )THEN
           
             WRITE(clformat,'(a,i2,a)') '(A40,', nb_class_max,'(f8.3,1X))' 
@@ -416,5 +416,5 @@
            !debug
            !-----
-           IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )THEN
+           IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )THEN
               WRITE(numout,*)"      List of points in global domain:"
               DO jpt=1,iptglo
@@ -450,5 +450,5 @@
            !debug
            !-----
-           IF(   lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )THEN
+           IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )THEN
               WRITE(numout,*)"      List of points selected by the proc:"
               DO jpt = 1,iptloc
@@ -468,5 +468,5 @@
            !remove redundant points between processors
            !------------------------------------------
-           lldebug = .FALSE. ; IF ( (jsec==nn_secdebug .OR. nn_secdebug==-1) .AND. lwp ) lldebug = .TRUE.
+           lldebug = .FALSE. ; IF ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) lldebug = .TRUE.
            IF( iptloc .NE. 0 )THEN
               CALL removepoints(secs(jsec),'I','top_list',lldebug)
@@ -484,5 +484,5 @@
            !debug
            !-----
-           IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )THEN
+           IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )THEN
               WRITE(numout,*)"      List of points after removepoints:"
               iptloc = secs(jsec)%nb_point
@@ -496,5 +496,5 @@
 
         ELSE  ! iptglo = 0
-           IF( lwp .AND. ( jsec==nn_secdebug .OR. nn_secdebug==-1 ) )&
+           IF( jsec==nn_secdebug .OR. nn_secdebug==-1 )&
               WRITE(numout,*)'   No points for this section.'
         ENDIF
Index: /branches/2015/nemo_v3_6_STABLE/NEMOGCM/TOOLS/SECTIONS_DIADCT/src/compute_sections.f90
===================================================================
--- /branches/2015/nemo_v3_6_STABLE/NEMOGCM/TOOLS/SECTIONS_DIADCT/src/compute_sections.f90	(revision 8126)
+++ /branches/2015/nemo_v3_6_STABLE/NEMOGCM/TOOLS/SECTIONS_DIADCT/src/compute_sections.f90	(revision 8127)
@@ -681,6 +681,7 @@
      IF( sec%nb_point .ne. 0 )THEN
         IF (  sec%listPoint(sec%nb_point)%I .NE.  sec%listPoint(1)%I ) THEN
-           sec%slopeSection = ( sec%listPoint(sec%nb_point)%J - sec%listPoint(1)%J ) /  &
-                              ( sec%listPoint(sec%nb_point)%I - sec%listPoint(1)%I )      
+           sec%slopeSection = REAL( ( sec%listPoint(sec%nb_point)%J - sec%listPoint(1)%J ) , wp )/  &
+                              REAL( ( sec%listPoint(sec%nb_point)%I - sec%listPoint(1)%I ) , wp )
+
         ELSE
            sec%slopeSection = 10000._wp