Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 8075)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/trcini_cfc.F90	(revision 8130)
@@ -70,5 +70,5 @@
       !                                ! Allocate CFC arrays
 
-      ALLOCATE( p_cfc(jpyear,jphem,2), STAT=ierr )
+      ALLOCATE( p_cfc(jpyear,jphem,3), STAT=ierr )
       IF( ierr > 0 ) THEN
          CALL ctl_stop( 'trc_ini_cfc: unable to allocate p_cfc array' )   ;   RETURN
@@ -91,8 +91,5 @@
          ENDIF
          qint_cfc(:,:,:) = 0._wp
-         DO jl = 1, jp_cfc
-            jn = jp_cfc0 + jl - 1
-            trn(:,:,:,jn) = 0._wp
-         END DO
+         trn(:,:,:,jp_cfc0:jp_cfc1) = 0._wp
       ENDIF
 
@@ -107,5 +104,5 @@
       DO 
         READ(inum,*, IOSTAT=io) zyy, p_cfc(jn,1,1), p_cfc(jn,1,2), &
-             & p_cfc(jn,1,3), p_cfc(jn,2,1) &
+             & p_cfc(jn,1,3), p_cfc(jn,2,1),  &
              & p_cfc(jn,2,2), p_cfc(jn,2,3)
         IF( io < 0 ) exit
@@ -128,5 +125,5 @@
          DO jn = 30, jpyear
             WRITE(numout, '( 1I4, 6F9.2)') jn, p_cfc(jn,1,1), p_cfc(jn,2,1), &
-                 & p_cfc(jn,1,2), p_cfc(jn,2,2) &
+                 & p_cfc(jn,1,2), p_cfc(jn,2,2), &
                  & p_cfc(jn,1,3), p_cfc(jn,2,3)
          END DO
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 8075)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 8130)
@@ -136,8 +136,8 @@
          !! 2 -- Hindcast/proj
          iyear_beg = MOD(nyear, 100)
-         IF (iyear_beg < 9)  iyear_beg = iyear_beg + 100
+         IF (iyear_beg < 20)  iyear_beg = iyear_beg + 100
          !! JPALM -- Same than previously, if iyear_beg is out of P_cfc range,
          !!       we want to set p_CFC to 0.00 --> set iyear_beg = 10
-         IF ((iyear_beg < 30) .OR. (iyear_beg > 107)) iyear_beg = 10             
+         IF ((iyear_beg < 30) .OR. (iyear_beg > 115)) iyear_beg = 10             
       ENDIF
       !!
@@ -258,10 +258,10 @@
       !
       IF( lk_iomput ) THEN
-         CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
-         CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
-         CALL iom_put( "qtrCFC12"  , qtr_cfc (:,:,2) )
-         CALL iom_put( "qintCFC12" , qint_cfc(:,:,2) )
-         CALL iom_put( "qtrSF6"    , qtr_cfc (:,:,3) )
-         CALL iom_put( "qintSF6"   , qint_cfc(:,:,4) )
+         IF  (iom_use("qtrCFC11"))  CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
+         IF  (iom_use("qintCFC11")) CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
+         IF  (iom_use("qtrCFC12"))  CALL iom_put( "qtrCFC12"  , qtr_cfc (:,:,2) )
+         IF  (iom_use("qintCFC12")) CALL iom_put( "qintCFC12" , qint_cfc(:,:,2) )
+         IF  (iom_use("qtrSF6"))    CALL iom_put( "qtrSF6"    , qtr_cfc (:,:,3) )
+         IF  (iom_use("qintSF6"))   CALL iom_put( "qintSF6"   , qint_cfc(:,:,3) )
       ELSE
          IF( ln_diatrc ) THEN
@@ -271,5 +271,5 @@
             trc2d(:,:,jp_cfc0_2d + 3) = qint_cfc(:,:,2)
             trc2d(:,:,jp_cfc0_2d + 4) = qtr_cfc (:,:,3)
-            trc2d(:,:,jp_cfc0_2d + 5) = qint_cfc(:,:,4)
+            trc2d(:,:,jp_cfc0_2d + 5) = qint_cfc(:,:,3)
          END IF
       END IF
@@ -376,9 +376,6 @@
             qtr_cfc(:,:,:) = 0._wp
             qint_cfc(:,:,:) = 0._wp
-            DO jl = 1, jp_cfc
-              jn = jp_cfc0 + jl - 1
-              trn(:,:,:,jn) = 0._wp
-              trb(:,:,:,jn) = 0._wp
-            END DO
+            trn(:,:,:,jp_cfc0:jp_cfc1) = 0._wp
+            trb(:,:,:,jp_cfc0:jp_cfc1) = 0._wp
          ENDIF
       !!
@@ -386,6 +383,6 @@
       ELSEIF (simu_type==2) THEN
          iyear_beg = MOD(nyear, 100)
-         IF (iyear_beg < 9)  iyear_beg = iyear_beg + 100
-         IF ((iyear_beg < 30) .OR. (iyear_beg > 107)) THEN
+         IF (iyear_beg < 20)  iyear_beg = iyear_beg + 100
+         IF ((iyear_beg < 30) .OR. (iyear_beg > 115)) THEN
             qtr_cfc(:,:,:) = 0._wp
             IF(lwp) THEN
@@ -398,9 +395,6 @@
             qtr_cfc(:,:,:) = 0._wp
             qint_cfc(:,:,:) = 0._wp
-            DO jl = 1, jp_cfc
-              jn = jp_cfc0 + jl - 1
-              trn(:,:,:,jn) = 0._wp
-              trb(:,:,:,jn) = 0._wp
-            END DO
+            trn(:,:,:,jp_cfc0:jp_cfc1) = 0._wp
+            trb(:,:,:,jp_cfc0:jp_cfc1) = 0._wp
          ENDIF
       ENDIF