Index: branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8150)
+++ branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8151)
@@ -469,5 +469,5 @@
       ALLOCATE( sist   (jpi,jpj) , t_bo   (jpi,jpj) ,                                           &
          &      frld   (jpi,jpj) , pfrld  (jpi,jpj) , phicif (jpi,jpj) ,                        &
-         &      wfx_snw(jpi,jpj) , wfx_snw_dyn(jpi,jpj), wfx_snw_sum(jpi,jpj)                   &
+         &      wfx_snw(jpi,jpj) , wfx_snw_dyn(jpi,jpj), wfx_snw_sum(jpi,jpj) ,                 &
          &      wfx_ice(jpi,jpj) , wfx_sub(jpi,jpj) ,                                           &
          &      wfx_bog(jpi,jpj) , wfx_dyn(jpi,jpj) , wfx_bom(jpi,jpj) , wfx_sum(jpi,jpj) ,     &
Index: branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90
===================================================================
--- branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 8150)
+++ branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 8151)
@@ -655,15 +655,15 @@
       CALL lbc_lnk_multi( diag_sig1   , 'T',  1., diag_sig2   , 'T',  1., &
                  &        diag_dssh_dx, 'U', -1., diag_dssh_dy, 'V', -1., &
-                 &        diag_corstrx, 'U', -1., diag_corstry, 'V', -1.  & 
+                 &        diag_corstrx, 'U', -1., diag_corstry, 'V', -1., & 
                  &        diag_intstrx, 'U', -1., diag_intstry, 'V', -1.  )
 
-      CALL lbc_lnk( diag_dssh_dx, 'U', -1. )
-      CALL lbc_lnk( diag_dssh_dy, 'V', -1. )
-
-      CALL lbc_lnk( diag_intstrx, 'U', -1. )
-      CALL lbc_lnk( diag_intstry, 'V', -1. )
-
-      CALL lbc_lnk( diag_corstrx, 'U', -1. )
-      CALL lbc_lnk( diag_corstry, 'V', -1. )
+!     CALL lbc_lnk( diag_dssh_dx, 'U', -1. )
+!     CALL lbc_lnk( diag_dssh_dy, 'V', -1. )
+
+!     CALL lbc_lnk( diag_intstrx, 'U', -1. )
+!     CALL lbc_lnk( diag_intstry, 'V', -1. )
+
+!     CALL lbc_lnk( diag_corstrx, 'U', -1. )
+!     CALL lbc_lnk( diag_corstry, 'V', -1. )
             
       !
Index: branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90
===================================================================
--- branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90	(revision 8150)
+++ branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90	(revision 8151)
@@ -78,5 +78,6 @@
          &         zui, zuj, zvi, zvj                                          ! strait addresses
 
-      INTEGER  :: Nu, Nv                                                       ! passage size
+      INTEGER  :: Nu, Nv, &                                                    ! passage size
+                  i_strait                                                     ! strait number
 
       INTEGER, DIMENSION(4)  :: ji0, ji1, jj0, jj1
@@ -388,6 +389,6 @@
          DO i_strait = 1, 4, 3
 
-            DO ji = mi0(ji0), mi1(ji1)
-               jj = mj0(jj0)
+            DO ji = mi0( ji0(i_strait) ), mi1(ji1 (i_strait) )
+               jj = mj0( jj0(i_strait) )
    
                zdiag_area_strait(i_strait) = zdiag_area_strait(i_strait)                                 &     ! --- ice area flux ---
Index: branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/thd_ice.F90
===================================================================
--- branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/thd_ice.F90	(revision 8150)
+++ branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/LIM_SRC_3/thd_ice.F90	(revision 8151)
@@ -161,5 +161,5 @@
       !
       ALLOCATE( sprecip_1d (jpij) , frld_1d    (jpij) , at_i_1d    (jpij) ,                     &
-         &      fhtur_1d   (jpij) , wfx_snw_1d (jpij) , wfx_spr_1d (jpij) ,                     &
+         &      fhtur_1d   (jpij) , wfx_snw_1d (jpij) , wfx_snw_sum_1d(jpij), wfx_spr_1d (jpij) , &
          &      fhld_1d    (jpij) , wfx_sub_1d (jpij) , wfx_bog_1d (jpij) , wfx_bom_1d(jpij) ,  &
          &      wfx_sum_1d(jpij)  , wfx_sni_1d (jpij) , wfx_opw_1d (jpij) , wfx_res_1d(jpij) ,  &
Index: branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 8150)
+++ branches/2016/v3_6_CMIP6_ice_diagnostics/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 8151)
@@ -615,6 +615,5 @@
 
       ! SIMIP diagnostics
-      diag_dms_sum(:,:)  = 0._wp ; diag_dms_dyn(:,:)  = 0._wp
-      diag_dmi_dyn(:,:)  = 0._wp ;
+      diag_dms_dyn(:,:)  = 0._wp ; diag_dmi_dyn(:,:)  = 0._wp
       diag_fc_bo(:,:)    = 0._wp ; diag_fc_su(:,:)    = 0._wp
       